--AH:ScriptId=fb1053ea-0c8e-4e6b-b2cd-ef97742396f2;371
CREATE TABLE [Dashboards]
(
  [Dashboard_Id] INT IDENTITY(1,1) NOT NULL,
    CONSTRAINT [PK__Dashboards]
    PRIMARY KEY ([Dashboard_Id]),
  [Application_Id] INT NULL,
    CONSTRAINT [FK__Dashboards__Applications]
    FOREIGN KEY ([Application_Id])
    REFERENCES [Applications] ([Application_Id]),
  [User_Name] USERNAME,
  [DashboardScope_Code] CHAR(1) NOT NULL,
    CONSTRAINT [CK__Dashboards__DashboardScope_Code_Domain]
    CHECK ([DashboardScope_Code] IN ('S', 'A', 'R', 'B')),
  CONSTRAINT [UQ__Dashboards__Unique]
    UNIQUE ([Application_Id], [User_Name], [DashboardScope_Code])
)

GO

-- S: System
-- A: Application
-- R: Release
-- B: Build

CREATE TABLE [DashboardGadgets]
(
  [Gadget_Id] INT IDENTITY(1,1) NOT NULL,
    CONSTRAINT [PK__DashboardGadgets]
    PRIMARY KEY ([Gadget_Id]),

  [Dashboard_Id] INT NOT NULL,
    CONSTRAINT [FK__DashboardGadgets__Dashboards]
    FOREIGN KEY ([Dashboard_Id])
    REFERENCES [Dashboards] ([Dashboard_Id]),
    
  [Dashboard_Zone] INT NOT NULL,
  CONSTRAINT [CK__DashboardGadgets__Dashboard_Zone_Check] CHECK ([Dashboard_Zone] >= 1 AND [Dashboard_Zone] <= 4),

  [Display_Sequence] INT NOT NULL,
  CONSTRAINT [CK__DashboardGadgets__Display_Sequence_Check] CHECK ([Display_Sequence]>0),
  
  [DashboardGadget_Name] VARCHAR(50) NOT NULL,
  [DashboardGadget_Description] VARCHAR(MAX) NOT NULL,
  [DashboardGadget_Configuration] VARCHAR(MAX) NOT NULL,
  
  [CreatedBy_User_Name] USERNAME NOT NULL,
  [CreatedOn_Date] DATETIME NOT NULL,
  [ModifiedBy_User_Name] USERNAME NOT NULL,
  [ModifiedOn_Date] DATETIME NOT NULL,
  
  CONSTRAINT [UQ__DashboardGadgets__Unique]
  UNIQUE ([Dashboard_Id], [Dashboard_Zone], [Display_Sequence])
)

GO

INSERT INTO [Dashboards]
(
  [DashboardScope_Code]
)
VALUES
(
  'S'
)

INSERT INTO [Dashboards]
(
  [Application_Id],
  [DashboardScope_Code]
)
SELECT [Application_Id], [DashboardScope_Code] = 'A'
  FROM [Applications]

INSERT INTO [Dashboards]
(
  [Application_Id],
  [DashboardScope_Code]
)
SELECT [Application_Id], [DashboardScope_Code] = 'R'
  FROM [Applications]

INSERT INTO [Dashboards]
(
  [Application_Id],
  [DashboardScope_Code]
)
SELECT [Application_Id], [DashboardScope_Code] = 'B'
  FROM [Applications]

