--AH:ScriptId=75b06017-3c20-42b9-bbcd-2563caaa077f;3067
CREATE TABLE [Variables]
(
    [Variable_Id] INT IDENTITY(1,1) NOT NULL,
    [Variable_Name] VARCHAR(50) NOT NULL,
    [ValueType_Code] CHAR(1) NOT NULL,
    [Variable_Value] VARBINARY(MAX) NOT NULL,
    [Sensitive_Indicator] YNINDICATOR NOT NULL,
    [EvaluateVariables_Indicator] YNINDICATOR NOT NULL,

    [Environment_Id] INT NULL,
    [ServerRole_Id] INT NULL,
    [Server_Id] INT NULL,
    [ApplicationGroup_Id] INT NULL,
    [Application_Id] INT NULL,
    [Deployable_Id] INT NULL,

    CONSTRAINT [PK__Variables] PRIMARY KEY ([Variable_Id]),
    CONSTRAINT [CK__Variables__ValueType_Code] CHECK ([ValueType_Code] IN ('S', 'V', 'M')),
    CONSTRAINT [CK__Variables__Variable_Name] CHECK (LEN([Variable_Name]) > 0),
    CONSTRAINT [FK__Variables__Environments] FOREIGN KEY ([Environment_Id]) 
               REFERENCES [Environments] ([Environment_Id])
               ON DELETE CASCADE,
    CONSTRAINT [FK__Variables__Servers] FOREIGN KEY ([Server_Id]) 
               REFERENCES [Servers] ([Server_Id])
               ON DELETE CASCADE,
    CONSTRAINT [FK__Variables__ServerRoles] FOREIGN KEY ([ServerRole_Id]) 
               REFERENCES [ServerRoles] ([ServerRole_Id])
               ON DELETE CASCADE,
    CONSTRAINT [FK__Variables__ApplicationGroups] FOREIGN KEY ([ApplicationGroup_Id]) 
               REFERENCES [ApplicationGroups] ([ApplicationGroup_Id])
               ON DELETE CASCADE,
    CONSTRAINT [FK__Variables__Applications] FOREIGN KEY ([Application_Id]) 
               REFERENCES [Applications] ([Application_Id])
               ON DELETE CASCADE,
    CONSTRAINT [FK__Variables__Deployables] FOREIGN KEY ([Deployable_Id]) 
               REFERENCES [Deployables] ([Deployable_Id])
               ON DELETE CASCADE
)
GO

CREATE TABLE [ReleaseVariables]
(
    [Release_Id] INT NOT NULL,
    [Variable_Name] VARCHAR(50) NOT NULL,
    [ValueType_Code] CHAR(1) NOT NULL,
    [Variable_Value] VARBINARY(MAX) NOT NULL,

    CONSTRAINT [PK__ReleaseVariables] PRIMARY KEY ([Release_Id], [Variable_Name]),
    CONSTRAINT [FK__ReleaseVariables__Releases] FOREIGN KEY ([Release_Id])
               REFERENCES [Releases] ([Release_Id])
               ON DELETE CASCADE
)

CREATE TABLE [BuildVariables]
(
    [Build_Id] INT NOT NULL,
    [Variable_Name] VARCHAR(50) NOT NULL,
    [ValueType_Code] CHAR(1) NOT NULL,
    [Variable_Value] VARBINARY(MAX) NOT NULL,

    CONSTRAINT [PK__BuildVariables] PRIMARY KEY ([Build_Id], [Variable_Name]),
    CONSTRAINT [FK__BuildVariables__Builds] FOREIGN KEY ([Build_Id])
               REFERENCES [Builds] ([Build_Id])
               ON DELETE CASCADE
)