IF OBJECT_ID('TR__Builds__ValidateApplication') IS NOT NULL DROP TRIGGER [TR__Builds__ValidateApplication]
GO

CREATE TRIGGER [TR__Builds__ValidateApplication]
       ON [Builds] FOR UPDATE, INSERT
AS 
BEGIN
	--Ensure that the Application_Id column is consistent with the associated relase and pipeline
	IF EXISTS(SELECT *
	            FROM inserted i
				     INNER JOIN [Releases] R
					         ON R.[Release_Id] = i.[Release_Id]
			   WHERE (i.[Release_Id] IS NOT NULL AND COALESCE(i.[Application_Id], -1) <> COALESCE(R.[Application_Id], -1)))
	BEGIN
		RAISERROR('An invalid Application_Id was provided for this Build.', 16, 1)
		ROLLBACK
	END
END
GO
