IF OBJECT_ID('[BuildTestResults_Extended]') IS NOT NULL DROP VIEW [BuildTestResults_Extended]
GO

CREATE VIEW [BuildTestResults_Extended] AS

SELECT BTR.*
      ,[TestEnded_Date] = DATEADD(s,CAST(([TestDuration_Milliseconds] / 1000) AS INT),[TestStarted_Date])

      ,A.[Application_Id]
      ,A.[Application_Name]
	  ,R.[Release_Id]
      ,R.[Release_Number]
      ,[Release_Name] = COALESCE(R.[Release_Name], R.[Release_Number])

	  ,B.[Build_Id]
	  ,B.[Build_Number]
	  ,BP.[Promotion_Id]
	  ,BP.[PipelineStage_Name]
	  ,[Pipeline_Name] = COALESCE(R.[Pipeline_Name], B.[Pipeline_Name])

  FROM [BuildTestResults] BTR
	   INNER JOIN [PipelineStageTargetExecutions] PSTE
	           ON PSTE.[Execution_Id] = BTR.[Execution_Id]
	   INNER JOIN [BuildPromotions] BP
	           ON BP.[Promotion_Id] = PSTE.[Promotion_Id]
	   INNER JOIN [Builds] B
	           ON B.[Build_Id] = BP.[Build_Id]
	    LEFT JOIN [Releases] R
	           ON R.[Release_Id] = B.[Release_Id]
	    LEFT JOIN [Applications] A
	           ON A.[Application_Id] = B.[Application_Id]
GO
