EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ApplicationGroups_DeleteApplicationGroup',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes an application group'
GO

IF OBJECT_ID('[ApplicationGroups_DeleteApplicationGroup]') IS NOT NULL DROP PROCEDURE [ApplicationGroups_DeleteApplicationGroup]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ApplicationGroups_DeleteApplicationGroup]
(
	@ApplicationGroup_Id INT
)
AS
BEGIN

SET NOCOUNT ON 

BEGIN TRY
	BEGIN TRANSACTION
	
        UPDATE [Applications]
           SET [ApplicationGroup_Id] = NULL
         WHERE [ApplicationGroup_Id] = @ApplicationGroup_Id

         UPDATE [ApplicationGroups]
           SET [Parent_ApplicationGroup_Id] = NULL
         WHERE [Parent_ApplicationGroup_Id] = @ApplicationGroup_Id

        DELETE [EventListenerApplicationGroups]
         WHERE [ApplicationGroup_Id] = @ApplicationGroup_Id

        DELETE [Privileges]
         WHERE [ApplicationGroup_Id] = @ApplicationGroup_Id


        DELETE [RetentionPolicies]
         WHERE [PurgeIn_ApplicationGroup_Id] = @ApplicationGroup_Id

		DELETE [ApplicationGroups]
		 WHERE [ApplicationGroup_Id] = @ApplicationGroup_Id
	
	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [ApplicationGroups_DeleteApplicationGroup] TO [BuildMasterUser_Role]
