EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Rafts_GetRaftItemsAccessibleToApplication',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'RaftItems_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the specified database application raft items including any global items.'
GO

IF OBJECT_ID('[Rafts_GetRaftItemsAccessibleToApplication]') IS NOT NULL DROP PROCEDURE [Rafts_GetRaftItemsAccessibleToApplication]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Rafts_GetRaftItemsAccessibleToApplication]
(
    @Application_Id INT,
	@Raft_Id INT,
	@RaftItemType_Code INT = NULL,
	@RaftItem_Name VARCHAR(255) = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT *
	  FROM [RaftItems_Extended]
	 WHERE [Raft_Id] = @Raft_Id
	   AND ([Application_Id] IS NULL OR [Application_Id] = @Application_Id)
	   AND ((@RaftItemType_Code IS NULL) OR ([RaftItemType_Code] = @RaftItemType_Code))
	   AND ((@RaftItem_Name IS NULL) OR ([RaftItem_Name] = @RaftItem_Name))
	   AND [Active_Indicator] = 'Y'
	ORDER BY CASE WHEN [Application_Id] IS NULL THEN 1 ELSE 0 END, [RaftItemType_Code], [RaftItem_Name]

END
GO

GRANT EXECUTE ON [Rafts_GetRaftItemsAccessibleToApplication] TO [BuildMasterUser_Role]